package fem;
import fem.result.Strain;
import fem.result.Stress;
import figure.Matrix;
import figure.Point3D;

//--------------------------------------------------------------------//
/**
 * vfC^[tFCX
 */
public interface Element extends GaussianQuadrature,LabeledData,Nodes{

//--------------------------------------------------------------------//
/**
 * ޗ̃CfbNXԂ
 * @return ޗ̃CfbNX
 */
  int getMaterial();

/**
 * ޗ̃CfbNXݒ肷
 * @param material ޗ̃CfbNX
 */
  void setMaterial(int material);

/**
 * vfEԂ
 * @return vfE
 */
  int borderCount();

/**
 * vfEԂ
 * @param element vfx
 * @return vfEi[z
 */
  ElementBorder[] borders(int element);

/**
 * vfEԂ
 * @param element vfx
 * @param index vfẼCfbNX
 * @return vfEi[z
 */
  ElementBorder border(int element,int index);

/**
 * vfߓ_̊pxԂ
 * @param p ߓ_i[z
 * @return vfߓ_̊pxi[z
 */
  double[] angle(Point3D p[]);

/**
 * ʃ}gbNXԂ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return ʃ}gbNX
 */
  Matrix massMatrix(Point3D p[],Material material);

/**
 * ʃ}gbNXԂ
 * @param p ߓ_i[z
 * @param density ޗ̖x
 * @return ʃ}gbNX
 */
  Matrix massMatrix(Point3D p[],double density);

/**
 * }gbNXԂ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return }gbNX
 */
  Matrix stiffnessMatrix(Point3D p[],Material material);

/**
 * }gbNXԂ
 * @param p ߓ_i[z
 * @param d1  - c}gbNX
 * @return }gbNX
 */
  Matrix stiffnessMatrix(Point3D p[],Matrix d1);

/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return `֐}gbNX
 */
  Matrix shapeFunctionMatrix(Point3D p[],Material material);

/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  Matrix shapeFunctionMatrix(Point3D p[],double coef);

/**
 * gU}gbNX<br>
 * { <i>N<sub>i</sub></i>E<i>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param material ޗ
 * @return gU}gbNX
 */
  Matrix gradMatrix(Point3D p[],Material material);

/**
 * gU}gbNX<br>
 * { <i>N<sub>i</sub></i>E<i>N<sub>j</sub> dV</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return gU}gbNX
 */
  Matrix gradMatrix(Point3D p[],double coef);

/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  Element copyElement();

/**
 * f[^Ԃ
 * @param material ޗx
 * @param p ߓ_i[z
 * @return ̃IuWFNg̕\
 */
  String toString(int material,Node p[]);
}
