package fem;
import fem.result.Strain;
import fem.result.Stress;
import figure.Matrix;
import figure.Point3D;
import figure.Vector3D;
import figure.Vector3DR;

//--------------------------------------------------------------------//
/**
 * VFvfC^[tFCX
 */
public interface ShellElement extends Element{

//--------------------------------------------------------------------//
/**
 * VFp[^̃CfbNXԂ
 * @return VFp[^̃CfbNX
 */
  int getParam();

/**
 * VFp[^̃CfbNXݒ肷
 * @param param VFp[^̃CfbNX
 */
  void setParam(int param);

/**
 * `֐s<br>
 * { <i>N<sub>i</sub></i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i> }<br>
 * Ԃ
 * @param xsi <i></i> W
 * @param eta <i></i> W
 * @return `֐s
 */
  Matrix shapeFunction(double xsi,double eta);

/**
 * @xNgԂ
 * @param p _i[z
 * @return @xNg
 */
  Vector3D normalVector(Point3D p[]);

/**
 * ]}gbNXԂ
 * @param p ߓ_i[z
 * @return ]}gbNX
 */
  Matrix dirMatrix(Point3D p[]);

/**
 * ʃ}gbNXԂ
 * @param p ߓ_i[z
 * @param material ޗ
 * @param t 
 * @return ʃ}gbNX
 */
  Matrix massMatrix(Point3D p[],Material material,double t);

/**
 * ʃ}gbNXԂ
 * @param p ߓ_i[z
 * @param density ޗ̖x
 * @param t 
 * @return ʃ}gbNX
 */
  Matrix massMatrix(Point3D p[],double density,double t);

/**
 * }gbNXԂ
 * @param p ߓ_i[z
 * @param material ޗ
 * @param t 
 * @return }gbNX
 */
  Matrix stiffnessMatrix(Point3D p[],Material material,double t);

/**
 * }gbNXԂ
 * @param p ߓ_i[z
 * @param d1  - c}gbNX
 * @param t 
 * @return }gbNX
 */
  Matrix stiffnessMatrix(Point3D p[],Matrix d1,double t);

/**
 * vfcԂ
 * @param p ߓ_i[z
 * @param u ߓ_ψʂi[z
 * @param zeta co͂ʂ <i></i> W
 * @param t vf̌
 * @return vfci[z
 */
  Strain[] strain(Point3D p[],Vector3DR u[],double zeta,double t);

/**
 * vf͂Ԃ
 * @param p ߓ_i[z
 * @param u ߓ_ψʂi[z
 * @param material ޗ
 * @param zeta co͂ʂ <i></i> W
 * @param t vf̌
 * @return vf͂i[z
 */
  Stress[] stress(Point3D p[],Vector3DR u[],Material material,
      	      	  double zeta,double t);

/**
 * vf͂Ԃ
 * @param p ߓ_i[z
 * @param u ߓ_ψʂi[z
 * @param d1  - c}gbNX
 * @param zeta co͂ʂ <i></i> W
 * @param t vf̌
 * @return vf͂i[z
 */
  Stress[] stress(Point3D p[],Vector3DR u[],Matrix d1,double zeta,
      	      	  double t);

/**
 * f[^Ԃ
 * @param material ޗx
 * @param param VFp[^x
 * @param p ߓ_i[z
 * @return ̃IuWFNg̕\
 */
  String toString(int material,int param,Node p[]);
}
