package fem.bc;
import fem.LabeledData;
import figure.Vector3DR;

//--------------------------------------------------------------------//
/**
 * ׏dNX
 */
public class Load extends Vector3DR implements LabeledData{

/** ߓ_x */
  public int node;

/**
 * ׏d\z
 * @param node ߓ_x
 * @param x <i>x</i> 
 * @param y <i>y</i> 
 * @param z <i>z</i> 
 */
  public Load(int node,double x,double y,double z){
    this(node,x,y,z,0.0,0.0,0.0);
  }

/**
 * ׏d\z
 * @param node ߓ_x
 * @param x <i>x</i> 
 * @param y <i>y</i> 
 * @param z <i>z</i> 
 * @param rx <i>x</i> ]p
 * @param ry <i>y</i> ]p
 * @param rz <i>z</i> ]p
 */
  public Load(int node,double x,double y,double z,
      	      double rx,double ry,double rz){
    super(x,y,z,rx,ry,rz);
    this.node=node;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xԂ
 * @return ߓ_x
 */
  public int label(){
    return node;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xݒ肷
 * @param node ߓ_x
 */
  public void setLabel(int node){
    this.node=node;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>Load</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Load){
     if(!super.equals(obj)) return false;
      Load l=(Load)obj;
      return (node==l.node);
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return toString(node);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @param node ߓ_x
 * @return ̃IuWFNg̕\
 */
  public String toString(int node){
    return "Load\t"+node+"\t"+x+"\t"+y+"\t"+z+"\t"+rx+"\t"+ry+"\t"+rz;
  }
}
