package fem;
import figure.Matrix;
import figure.Point3D;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * vfEC^[tFCX
 */
public interface ElementBorder extends GaussianQuadrature,Nodes{

//--------------------------------------------------------------------//
/**
 * 񏇂ɕ񂾐ߓ_xԂ
 * @return ߓ_x񏇂ɕׂĊi[z
 */
  int[] cycleNodes();

/**
 * vfxԂ
 * @return vfx
 */
  int element();

/**
 * vfxĐݒ肷
 * @param element vfx
 */
  void resetElementLabel(int element);

/**
 * vfE𕪊
 * @return vfEi[z
 */
  ElementBorder[] splitBorder();

/**
 * `֐s<br>
 * { <i>N<sub>i</sub></i>
 *   <i>dN<sub>i</sub></i> /<i>d</i>
 *   <i>dN<sub>i</sub></i> /<i>d</i> }<br>
 * Ԃ
 * @param xsi <i></i> W
 * @param eta <i></i> W
 */
  Matrix shapeFunction(double xsi,double eta);

/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  Matrix shapeFunctionMatrix(Point3D p[],double coef);

/**
 * `֐xNg<br>
 * { <i>N<sub>i</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐xNg
 */
  Vector shapeFunctionVector(Point3D p[],double coef);

/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  ElementBorder copyBorder();

/**
 * f[^Ԃ
 * @param p ߓ_i[z
 * @return ̃IuWFNg̕\
 */
  String toString(Node p[]);
}
