package fem.component;
import java.awt.Choice;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import fem.AnalyzeType;
import fem.result.Result;

//--------------------------------------------------------------------//
/**
 * \ʐIj[
 */
public class ResultChoice extends Choice implements ItemListener{

/** pl */
  protected FEMControlPanel panel;

/**
 * \ʐIj[\z
 * @param panel pl
 */
  public ResultChoice(FEMControlPanel panel){
    super();
    this.panel=panel;
    switch(panel.getModel().getAnalyzeType()){
      case STRUCTURE:
      	for(int i=0;i<FEMControlPanel.PARAMS.length;i++){
      	  add(FEMControlPanel.PARAMS[i]);
      	}
      	break;
      case HEAT_TRANSFER:
      	add(FEMControlPanel.PARAMS[0]);
      	add(FEMControlPanel.TEMPERATURE);
      	break;
    }
    select(FEMControlPanel.PARAMS[0]);
    addItemListener(this);
  }

//--------------------------------------------------------------------//
/**
 * \錋ʂ̐I
 * @param e ANVƂCxg
 */
  public void itemStateChanged(ItemEvent e){
    Object obj=e.getSource();
    if(obj instanceof Choice){
      Choice choice=(Choice)obj;
      panel.setContourParam((String)choice.getSelectedItem());
    }
  }
}
