package fem.result;
import figure.Tensor3D;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * cNX
 */
public class Strain extends Tensor3D{

/**
 * cftHg 0 ō\z
 */
  public Strain(){
    super();
  }

/**
 * xNgc\z
 * @param vector xNg
 */
  public Strain(Vector vector){
    this(vector.get(0),vector.get(1),vector.get(2),
      	 0.5*vector.get(3),0.5*vector.get(4),0.5*vector.get(5));
  }

/**
 * c\z
 * @param x <i>xx</i> 
 * @param y <i>yy</i> 
 * @param z <i>zz</i> 
 * @param xy <i>xy</i> 
 * @param yz <i>yz</i> 
 * @param zx <i>zx</i> 
 */
  public Strain(double x,double y,double z,
      	      	double xy,double yz,double zx){
    super(x,y,z,xy,yz,zx);
  }

//--------------------------------------------------------------------//
/**
 * e\xNgƂĕԂ
 * @return ̃e\\ <code>Vector</code>
 */
  public Vector vector(){
    Vector vector=new Vector(6);
    vector.set(0,xx);
    vector.set(1,yy);
    vector.set(2,zz);
    vector.set(3,2.0*xy);
    vector.set(4,2.0*yz);
    vector.set(5,2.0*xz);
    return vector;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Strain</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Strain){
      return super.equals(obj);
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Strain\t"+xx+"\t"+yy+"\t"+zz+"\t"+xy+"\t"+yz+"\t"+zx;
  }
}
