package fem.result;
import figure.Tensor3D;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * ̓NX
 */
public class Stress extends Tensor3D{

/**
 * ͂ftHg 0 ō\z
 */
  public Stress(){
    super();
  }

/**
 * xNg牞͂\z
 * @param vector xNg
 */
  public Stress(Vector vector){
    super(vector);
  }

/**
 * ͂\z
 * @param x <i>xx</i> 
 * @param y <i>yy</i> 
 * @param z <i>zz</i> 
 * @param xy <i>xy</i> 
 * @param yz <i>yz</i> 
 * @param zx <i>zx</i> 
 */
  public Stress(double x,double y,double z,
      	      	double xy,double yz,double zx){
    super(x,y,z,xy,yz,zx);
  }

//--------------------------------------------------------------------//
/**
 * ~[[X͂Ԃ
 * @return ~[[X
 */
  public double mises(){
    double ss=(xx-yy)*(xx-yy)+(yy-zz)*(yy-zz)+(zz-xx)*(zz-xx);
    double tt=xy*xy+yz*yz+zx*zx;
    return Math.sqrt(0.5*ss+3.0*tt);
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Stress</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Stress){
      return super.equals(obj);
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Stress\t"+xx+"\t"+yy+"\t"+zz+"\t"+xy+"\t"+yz+"\t"+zx;
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @param label f[^x
 * @return ̃IuWFNg̕\
 */
  public String toString(int label){
    return "Stress\t"+label+"\t"+xx+"\t"+yy+"\t"+zz
      	  +"\t"+xy+"\t"+yz+"\t"+zx;
  }
}
