package figure;

//--------------------------------------------------------------------//
/**
 * 3 xNgii{]jNX
 */
public class Vector3DR extends Vector3D{

/** <i>x</i> ]p */
  public double rx;

/** <i>y</i> ]p */
  public double ry;

/** <i>z</i> ]p */
  public double rz;

/**
 * ftHgl (0,0,0) ŃxNg\z
 */
  public Vector3DR(){
    this(0.0,0.0,0.0,0.0,0.0,0.0);
  }

/**
 * w肵ăxNg\z
 * @param x <i>x</i> 
 * @param y <i>y</i> 
 * @param z <i>z</i> 
 */
  public Vector3DR(double x,double y,double z){
    this(x,y,z,0.0,0.0,0.0);
  }

/**
 * w肵ăxNg\z
 * @param x <i>x</i> 
 * @param y <i>y</i> 
 * @param z <i>z</i> 
 * @param rx <i>x</i> ]p
 * @param ry <i>y</i> ]p
 * @param rz <i>z</i> ]p
 */
  public Vector3DR(double x,double y,double z,
      	      	   double rx,double ry,double rz){
    super(x,y,z);
    this.rx=rx;
    this.ry=ry;
    this.rz=rz;
  }

/**
 * xNg <code>v</code> ƓŃxNg\z
 * @param v QƂ <code>Vector3DR</code>
 */
  public Vector3DR(Vector3DR v){
    this(v.x,v.y,v.z,v.rx,v.ry,v.rz);
  }

//--------------------------------------------------------------------//
/**
 * <i>x</i> ]pݒ肷
 * @param rx <i>x</i> ]p
 */
  public void setRX(double rx){
    this.rx=rx;
  }

//--------------------------------------------------------------------//
/**
 * <i>y</i> ]pݒ肷
 * @param ry <i>y</i> ]p
 */
  public void setRY(double ry){
    this.ry=ry;
  }

//--------------------------------------------------------------------//
/**
 * <i>z</i> ]pݒ肷
 * @param rz <i>z</i> ]p
 */
  public void setRZ(double rz){
    this.rz=rz;
  }

//--------------------------------------------------------------------//
/**
 * ]p̑傫Ԃ
 * @return ]p̑傫
 */
  public double magnitudeR(){
    return Math.sqrt(rx*rx+ry*ry+rz*rz);
  }

//--------------------------------------------------------------------//
/**
 * ]p̑傫 2 Ԃ
 * @return ]p̑傫 2 
 */
  public double magnitudeSqR(){
    return rx*rx+ry*ry+rz*rz;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long lx=Double.doubleToLongBits(rx);
    long ly=Double.doubleToLongBits(ry);
    long lz=Double.doubleToLongBits(rz);
    int bit=super.hashCode();
    bit=31*bit+(int)(lx^(lx>>>32));
    bit=31*bit+(int)(ly^(ly>>>32));
    bit=31*bit+(int)(lz^(lz>>>32));
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Vector3DR</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Vector3DR){
      Vector3DR v=(Vector3DR)obj;
      return ((x==v.x) && (y==v.y) && (z==v.z)
      	   && (rx==v.rx) && (ry==v.ry) && (rz==v.rz));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Vector3DR\t"+x+"\t"+y+"\t"+z+"t"+rx+"\t"+ry+"\t"+rz;
  }
}
